<template lang="pug">
.my.grid
  template(
    v-for="item in recipe.items"
    )
    .column(
      )
      button.ui.basic.icon.button(
        v-if="!item.instance.raw"
        @click='toggle(item.instance)'
        )
        i.angle.icon(
          :class="recurse[item.instance.class] ? 'down' : 'right'"
          )
    .column.my.header {{ item.quantity }} x {{ item.instance.name }}
    .column
    .column.my.tree
      ItemTree(
        v-if="recurse[item.instance.class]"
        :item="item.instance"
        )
</template>

<script>
import ItemTree from './ItemTree.vue'

export default {
  components: { ItemTree },
  data () {
    const recurse = {}

    this.recipe.items.forEach((item) => { recurse[item.instance.class] = false })

    return {
      recurse
    }
  },
  methods: {
    toggle (item) {
      this.recurse[item.class] = !this.recurse[item.class]
    }
  },
  name: 'ItemTreeRecipe',
  props: {
    recipe: {
      validator (value) {
        return Array.isArray(value.items) &&
          /\d+/.test(value.time) &&
          /\d+/.test(value.yields)
      }
    }
  }
}
</script>

<style lang="sass" scoped>
.my.grid
  display: grid
  grid-gap: 10px
  grid-template-columns: auto 1fr
  grid-template-rows: 1fr auto

  .column
    align-items: center
    display: grid

.my.header
  font-size: 1.25rem
  font-weight: bold

.my.tree
  margin-left: 20px
</style>
